(function() {
    function OCFI2CInterface(packetParser, sendPacket) {
        OCFBaseInterface.apply(this, arguments);
        this.defprom = {};
    }
    OCFI2CInterface.prototype = new OCFBaseInterface();

    OCFI2CInterface.prototype.init = function(info) {// entire register file
        console.log('TODO ... echoing info');
        this.info = info;
        //console.log(info);
        // do enable comand; if success then config commands here
    };

    OCFI2CInterface.prototype.reset = function() {
        // TODO
    };

    OCFI2CInterface.prototype.handlePacket = function(packet) {
        // TODO decode packet;
        console.log(packet);
    };
    OCFI2CInterface.prototype.read = function(regInfo) {
        // TODO
        console.log(regInfo);
        //return this.I2C_ReadRegister(2, 0x51, 0, 0x60)//.bind(this);
    };
    OCFI2CInterface.prototype.write = function(regInfo, data) {
        // TODO decode packet;
        console.log(regInfo, data);
    };
    
    window.OCFI2CInterface = OCFI2CInterface;


    // Reference ocf_common.h
    //typedef struct _PACKED_STRUCT_ATTRIB
    //{
    //    uint16_t     signature;     // Packet signature (must be PACKET_SIGNATURE value)
    //    uint16_t     type;          // Type of packet
    //    uint32_t     transfer_len;  // Total number of bytes in the transfer
    //    uint16_t     packet_num;    // Sequential packet number
    //    OC_STATUS    status;        // Status code returned by command function
    //    uint16_t     payload_len;   // Number of bytes in the payload
    //    uint16_t     if_type_unit;  // Interface type and unit
    //    uint16_t     command;       // Command code
    //    uint16_t     reserved;      // unused (for 32-bit alignment)
    //    uint32_t     param[8];      // eight 32-bit parameters
    //} OCF_PACKET_HEADER;
    var COMMAND_PACKET = 0x0001;
    var PARAM_MAX = 8;
    OCFI2CInterface.prototype.h2c_command = function(unit, command, params, payload) {
        // host to controller
        var payload_len = payload && payload.length || 0;
        //Array.prototype.push.apply(params, payload);
        //var params_and_payload = payload_len && params.concat(payload) || params;
        var filledparams = fill_param(params, PARAM_MAX-params.length);
        // Someone will insert status and reserved
        var ph = {
            type: uint16_leb2(COMMAND_PACKET), //type
            transfer_len: uint32_leb4(0), // transfer_len
            packet_num: uint16_leb2(1), // packet_num
            //uint32_leb4(0), // status
            payload_len: uint16_leb2(payload_len), // payload_len
            if_type_unit: [unit & 0xff, I2C_Interface], // this is 16 bi le // Ref: if_type_unit: I2C_Interface << 8 | unit
            command: uint16_leb2(command), // command
            params: filledparams,
            payload: payload
        };
        var deferredpromise = Q.defer();
        this.defprom[ph.if_type_unit, ph.command, ph.payload_len, params] = deferredpromise;
        this.sendPacket(ph);        
        return deferredpromise;
    };
    var uint32_leb4 = function(val) {
        return [val & 0xff, (val >> 8) & 0xff, (val >> 16) & 0xff, (val >> 24) & 0xff];
    };
    var uint16_leb2 = function(val) {
        return [val & 0xff, (val >> 8) & 0xff];
    };
    var uint16_leb4 = function(val) {
        return [val & 0xff, (val >> 8) & 0xff, 0x0, 0x0];
    };
    var flatten = function(ary) {
        return ary.reduce(function(a,b) {return a.concat(Array.isArray(b) ? flatten(b) : b)}, [])
    };
    var fill_param = function(ary, n) {
        var ans = flatten(ary);
        for (var idx=0; idx<n*4; idx++)  ans.push(0);
        return ans;
    };
    var bytes_hex = function(bytes) {
        return Array.from(bytes, function(byte) {
            return ('0' + (byte & 0xFF).toString(16)).slice(-2);
        }).join(' ');
    };
    OCFI2CInterface.prototype.bytes_hex = bytes_hex; // for debug only
    OCFI2CInterface.prototype.bytes_ascii = function(bytes) { return String.fromCharCode.apply(null, bytes) };
    
    // Reference ocf_common.h
    //#define I2C_Interface       0x03
    //typedef enum
    //{
    //    ocCmd_I2C_Enable = 0x00,
    //    ocCmd_I2C_Config,
    //    ocCmd_I2C_Write,
    //    ocCmd_I2C_Read,
    //    ocCmd_I2C_WriteRegister,
    //    ocCmd_I2C_ReadRegister,
    //    ocCmd_I2C_BlkWriteBlkRead
    //} I2C_CMD;
    var I2C_Interface = 0x03;
    var ocCmd_I2C_Enable = 0x00;
    var ocCmd_I2C_Config = 0x01;
    var ocCmd_I2C_Write = 0x02;
    var ocCmd_I2C_Read = 0x03;
    var ocCmd_I2C_WriteRegister = 0x04;
    var ocCmd_I2C_ReadRegister = 0x05;
    var ocCmd_I2C_BlkWriteBlkRead = 0x06;
    
    OCFI2CInterface.prototype.I2C_Enable = function(unit, enable) {
        //uint32_t unit, bool enable
        var params = [uint32_leb4(unit), uint32_leb4(enable ? 1 : 0)];
        return this.h2c_command(unit, ocCmd_I2C_Enable, params);
    };
    var I2C_Enable_Reply = function() {
        
    };
    OCFI2CInterface.prototype.I2C_Config = function(unit, bit_rate, pull_ups) {
        //uint32_t unit, bit_rate, bool pull_ups
        // bit rate Reference ocf_defs.h
        //#define I2C_100_KBPS        0   // 100 kbps
        //#define I2C_400_KBPS        1   // 400 kbps
        //#define I2C_1000_KBPS       2   // 1.0 kbps
        //#define I2C_3400_KBPS       3   // 3.4 kbps
        if (bit_rate <0 || bit_rate>3) {
            console.log('Error Config bit rate needs to be [0..3]')
        }
        var params = [uint32_leb4(unit), uint32_leb4(bit_rate), uint32_leb4(pull_ups ? 1 : 0)];
        return this.h2c_command(unit, ocCmd_I2C_Config, params);
    };
    OCFI2CInterface.prototype.I2C_Write = function(unit, slaveAddr, pDataBuffer) {
        //uint8_t unit, uint8_t slaveAddr, uint16_t numBytes, uint8_t *pDataBuffer
        //uint16_t numBytes = pPacket->ph.payload_len;
        //Here, we deduce numBytes from pDataBuffer.length instead of an explicit argument
        var params = [uint32_leb4(unit), uint32_leb4(slaveAddr)];
        return this.h2c_command(unit, ocCmd_I2C_Write, params, pDataBuffer);
    };
    OCFI2CInterface.prototype.I2C_Read = function(unit, slaveAddr, numBytes) {
        //uint8_t unit, uint8_t slaveAddr, uint16_t numBytes, uint8_t *pDataBuffer
        // I think we don't need the caller of this method to give pDataBuffer for host to controller bound,
        // but TODO Test if we need to pre-alloc payload of size numBytes for this op (verify with the firmware code)
        var params = [uint32_leb4(unit), uint32_leb4(slaveAddr), uint16_leb4(numBytes)];
        return this.h2c_command(unit, ocCmd_I2C_Read, params);
    };
    OCFI2CInterface.prototype.I2C_WriteRegister = function(unit, slaveAddr, registerAddress, flags, pDataBuffer) {
        //uint8_t unit, uint8_t slaveAddr, uint32_t registerAddress,
		//uint32_t flags, uint16_t numBytes, uint8_t *pDataBuffer
        //flags: 0: 8-bit register address, 1: 16-bit register address.
        //uint16_t numBytes = pPacket->ph.payload_len;
        //Here, we deduce numBytes from pDataBuffer.length instead of an explicit argument
        var params = [uint32_leb4(unit), uint32_leb4(slaveAddr), uint32_leb4(registerAddress), uint32_leb4(flags)];
        return this.h2c_command(unit, ocCmd_I2C_WriteRegister, params, pDataBuffer);
    };
    OCFI2CInterface.prototype.I2C_ReadRegister = function(unit, slaveAddr, registerAddress, flags, numBytes) {
        //uint8_t unit, uint8_t slaveAddr, uint32_t registerAddress,
		//uint16_t flags, uint16_t numBytes, uint8_t *pDataBuffer
        // I think we don't need the caller of this method to give pDataBuffer for host to controller bound,
        // but TODO Test if we need to pre-alloc payload of size numBytes for this op (verify with the firmware code)
        //flags: 0: 8-bit register address, 1: 16-bit register address;
        //       Use Repeated START: 0: No repeated start (separate write and read), 2: Use repeated start
        //uint16_t numBytes = pPacket->ph.payload_len;
        //Here, we deduce numBytes from pDataBuffer.length instead of an explicit argument
        var params = [uint32_leb4(unit), uint32_leb4(slaveAddr), uint32_leb4(registerAddress), uint32_leb4(flags),
                      uint16_leb4(numBytes)];
        return this.h2c_command(unit, ocCmd_I2C_ReadRegister, params);
    };
    OCFI2CInterface.prototype.I2C_BlockWriteBlockRead = function(unit, slaveAddr, pWriteBuffer, numReadBytes) {
        //uint8_t unit, uint8_t slaveAddr, uint16_t numWriteBytes,
		//uint8_t *pWriteBuffer, uint16_t numReadBytes, uint8_t *pReadBuffer
        // I think we don't need the caller of this method to give pReadBuffer for host to controller bound,
        // but TODO Test if this is correct
        //uint16_t numWriteBytes = pPacket->ph.payload_len
        //Here, we deduce numWriteBytes from pWriteBuffer.length instead of an explicit argument
        var params = [uint32_leb4(unit), uint32_leb4(slaveAddr), uint16_leb4(numReadBytes)];
        return this.h2c_command(unit, ocCmd_I2C_BlkWriteBlkRead, params, pWriteBuffer);
    };


})();

